/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased_$type } from "./IIsCategoryBased";
import { IHasSingleValueCategory_$type } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline_$type } from "./IHasCategoryTrendline";
import { ITrendLineSeries_$type } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager_$type } from "./IAnchoredCategorySeriesInteractionManager";
import { DVContainer } from "igniteui-react-core";
import { enumGetBox, typeCast, Point_$type, markType, markDep } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { Series } from "./Series";
import { TrendLineType_$type } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap_$type } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { ICategoryScaler_$type } from "./ICategoryScaler";
import { IScaler_$type } from "./IScaler";
import { CategorySeriesView } from "./CategorySeriesView";
import { CategorySeriesMarkerCollisionAvoidance_$type } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior_$type } from "./ConsolidatedItemHitTestBehavior";
import { CategoryFramePreparer } from "./CategoryFramePreparer";
import { Rect } from "igniteui-react-core";
import { ISortingAxis_$type } from "./ISortingAxis";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { NumericAxisBase } from "./NumericAxisBase";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { NumericYAxis } from "./NumericYAxis";
import { ScalerParams } from "./ScalerParams";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { CollisionAvoider } from "./CollisionAvoider";
import { NonCollisionAvoider } from "./NonCollisionAvoider";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { PropertyMetadata } from "igniteui-react-core";
import { truncate, isNaN_, isInfinity } from "igniteui-react-core";
import { CategoryTrendLineManagerFactory } from "./CategoryTrendLineManagerFactory";
/**
 * @hidden
 */
export let AnchoredCategorySeries = /*@__PURE__*/ (() => {
    class AnchoredCategorySeries extends CategorySeries {
        constructor() {
            super();
            this.rq = null;
            this.ru = false;
            this.rs = null;
            this.rn = null;
            this.ry = null;
            this.pz = new CategoryFramePreparer(1, this, this.p3, this, this, this.p3.cr);
        }
        get rr() {
            if (this.rq == null) {
                this.rq = DVContainer.instance.createInstance(IAnchoredCategorySeriesInteractionManager_$type, () => this.cg.n);
            }
            return this.rq;
        }
        getHostReferenceValue() {
            return this.fa();
        }
        bp() {
            let a = new AnchoredCategorySeriesView(this);
            return a;
        }
        kk(a) {
            super.kk(a);
            this.rm = a;
        }
        gt(a, b) {
            let c = this.ic(b);
            if (c == AnchoredCategorySeries.$$p[2]) {
                return this.gu(a, b, this.r2);
            }
            return super.gt(a, b);
        }
        get valueColumn() {
            return this.rs;
        }
        set valueColumn(a) {
            if (this.rs != a) {
                let b = this.rs;
                this.rs = a;
                if (!this.ru) {
                    this.raisePropertyChanged("ValueColumn", b, this.rs);
                }
            }
        }
        get sk() {
            return this.c(AnchoredCategorySeries.r9);
        }
        set sk(a) {
            this.h(AnchoredCategorySeries.r9, a);
        }
        dq(a) {
            let b = new Rect(0, 0, 0, 1, 1);
            let c = this.fetchXAxis();
            let d = this.fetchYAxis();
            let e = this.n0(this.bs);
            let f = c != null ? this.pz.r(typeCast(ICategoryScaler_$type, c), b, b, e) : 0;
            return this.rr.c$a(this, this.valueColumn, c, d, f, a);
        }
        rj(a, b, c) {
            if (b < a || a < 0 || a > this.valueColumn.count || b < 0 || b > this.valueColumn.count || c == null) {
                return null;
            }
            let d = new Array((b - a) + 1);
            let e = c.cf;
            let f = null;
            if (e) {
                f = c.i$b;
            }
            for (let g = a; g <= b; g++) {
                let h = g;
                if (e) {
                    h = f._inner[h];
                }
                d[g - a] = this.cd.item(g);
            }
            return d;
        }
        kp(a, b, c, d) {
            super.kp(a, b, c, d);
            if (this.rm.c3 && this.rm.c2.g$b(a, b, c, d)) {
                this.k3(false);
                this.ka();
            }
            switch (b) {
                case "FastItemsSource":
                    if (typeCast(IFastItemsSource_$type, c) != null) {
                        c.deregisterColumn(this.valueColumn);
                        this.valueColumn = null;
                    }
                    if (typeCast(IFastItemsSource_$type, d) != null) {
                        this.valueColumn = this.ca(this.r2);
                    }
                    let e = typeCast(NumericAxisBase.$, this.fetchYAxis());
                    if (e != null && !e.cn()) {
                        this.rm.cr.g(this.fq);
                        this.k3(false);
                    }
                    break;
                case AnchoredCategorySeries.$$p[2]:
                    if (this.cd != null) {
                        this.cd.deregisterColumn(this.valueColumn);
                        this.valueColumn = this.ca(this.r2);
                    }
                    this.ry = this.r2;
                    break;
                case "ValueColumn":
                    if (this.rm.c3) {
                        this.rm.c2.g$i();
                    }
                    let f = typeCast(NumericAxisBase.$, this.fetchYAxis());
                    if (f != null && !f.cn()) {
                        this.rm.cr.g(this.fq);
                        this.k3(false);
                    }
                    this.r8();
                    this.lk();
                    break;
                case "TrendLineBrush":
                    this.lg();
                    break;
                case "ErrorBarSettings":
                    this.k3(false);
                    break;
                case "TrendLineType":
                    this.ka();
                    break;
                case AnchoredCategorySeries.$$p[1]:
                    this.k3(false);
                    break;
            }
        }
        ao(a) {
            if (this.valueColumn == null || this.valueColumn.count == 0) {
                return null;
            }
            if (a == this.fetchXAxis()) {
                return new AxisRange(0, this.valueColumn.count - 1);
            }
            if (a == this.fetchYAxis()) {
                return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
            }
            return null;
        }
        jo(a, b, c, d) {
            switch (a) {
                case 4:
                case 1:
                case 0:
                    this.rm.cr.g(this.fq);
                    break;
            }
            if (this.rm.c3) {
                this.rm.c2.g$e(a, b, c, d);
            }
            this.r8();
            this.lk();
        }
        qt() {
            return this.rv(this.p3);
        }
        rv(a) {
            let b = 0;
            let c = a.bv;
            let d = a.bu;
            let e = this.getEffectiveViewport1(a);
            let f = typeCast(NumericYAxis.$, this.fetchYAxis());
            if (!c.isEmpty && !d.isEmpty && f != null) {
                let g = new ScalerParams(0, c, d, f.ca, e);
                if (f.ch) {
                    g.b = this.fa();
                }
                b = f.dz(f.kn, g);
            }
            return b;
        }
        r7(a, b, c) {
            let d = this.rv(c);
            if (a.count > 0) {
                let e = d;
                a.add({ $type: Point_$type, x: a._inner[a.count - 1].x, y: e });
                a.add({ $type: Point_$type, x: a._inner[0].x, y: e });
            }
        }
        rk(a, b, c, d) {
            return this.rl(a, b, c, d, false);
        }
        rl(a, b, c, d, e) {
            return CategorySeries.pp(a, b, c, d, e);
        }
        ec(a, b, c) {
            let d = super.ec(a, b, c);
            let e = c;
            if (this.valueColumn == null || this.valueColumn.count == 0 || e.cr.d < 1) {
                d = false;
            }
            return d;
        }
        jl(a, b) {
            super.jl(a, b);
            let c = b;
            c.cx();
            if (c.c3) {
                c.c2.g$d();
            }
        }
        q9(a, b) {
            super.q9(a, b);
            this.p0(b).d(a, b);
        }
        rc(a, b) {
            super.rc(a, b);
            let c = typeCast(AnchoredCategorySeriesView.$, b);
            c.b3 = true;
            if (c.c3) {
                c.c2.g$g(a.p);
            }
            if (this.ok()) {
                CategoryMarkerManager.e(this, a.m, b.cu, this.om);
                this.q6(b, a);
                b.cm();
            }
            this.r4(a, b);
        }
        k2(a, b, c, d, e) {
            super.k2(a, b, c, d, e);
            let f = this.a3.a$h.item(d);
            let g = f;
            g.cr.g(this.fq);
            f.a1(c);
            if (this.cp(g)) {
                return;
            }
            if (this.rn == null) {
                this.rn = new CategoryFrame(3);
            }
            this.rn.u();
            this.q9(this.rn, g);
            this.rc(this.rn, g);
        }
        r4(a, b) {
        }
        lg() {
            super.lg();
            if (this.gi < 0) {
                return;
            }
            this.rm.c7();
            if (this.trendLineBrush != null) {
                this.rm.c5();
            }
            else {
                this.rm.c4();
            }
        }
        gw(a, b) {
            if (this.rm.c3 && a == this.rm.c2.g$j) {
                return null;
            }
            return super.gw(a, b);
        }
        get currentCategoryMode() {
            return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.pu()));
        }
        get scaler() {
            return typeCast(ICategoryScaler_$type, this.pu());
        }
        get yScaler() {
            return typeCast(IScaler_$type, this.qe());
        }
        get bucketizer() {
            return this.rm.cr;
        }
        get currentMode2Index() {
            return this.qx();
        }
        provideCollisionDetector() {
            if (this.ro == 1) {
                return new CollisionAvoider();
            }
            return NonCollisionAvoider.b;
        }
        get trendlinePreparer() {
            return this.rm.c3 ? this.rm.c2 : null;
        }
        jv(a) {
            super.jv(a);
            if (this.rm.c3) {
                this.a5.exportTrendlineData(this, a, this.rm.c2.g$j);
            }
        }
        gq(a) {
            let b = this.fetchXAxis();
            let c = this.fetchYAxis();
            return this.rr.c$b(this, a, this.qu(this.bs), this.valueColumn, b, c, this.rp == 1, (d) => super.gq(d));
        }
        get mayContainUnknowns() {
            return this.valueColumn == null || this.valueColumn.mayContainUnknowns;
        }
        fa() {
            return Series.fb(this.valueColumn, typeCast(ISortingAxis_$type, this.fetchXAxis()));
        }
        get_rx() {
            return 0;
        }
        get rx() {
            return this.get_rx();
        }
        ap(a) {
            if (a.isEmpty && this.b6 != null) {
                a = this.b6.os;
            }
            if (this.valueColumn == null) {
                return null;
            }
            let b = this.ny(this.bs);
            let c = this.pu();
            let d = new ScalerParams(0, a, this.b6.o7, c.ca, this.getEffectiveViewport());
            let e = (c.d2(b.left, d));
            let f = (c.d2(b.right, d));
            if (c.ca) {
                let g = e;
                e = f;
                f = g;
            }
            e -= this.rx;
            f += this.rx;
            let h = null;
            if (c.cf) {
                h = c;
                e = h.i$f(e);
                f = h.i$f(f);
            }
            else {
                e = Math.floor(e);
                f = Math.ceil(f);
            }
            if (isNaN_(e) || isNaN_(f)) {
                return null;
            }
            e = Math.max(0, Math.min(this.valueColumn.count - 1, e));
            f = Math.max(0, Math.min(this.valueColumn.count - 1, f));
            let i = 1.7976931348623157E+308;
            let j = -1.7976931348623157E+308;
            if (truncate(e) <= truncate(f)) {
                for (let k = truncate(e); k <= truncate(f); k++) {
                    let l = k;
                    if (h != null) {
                        l = h.i$b._inner[k];
                    }
                    let m = this.valueColumn.item(l);
                    if (this.valueColumn.mayContainUnknowns) {
                        if (isInfinity(m) || isNaN_(m)) {
                            continue;
                        }
                    }
                    i = Math.min(i, m);
                    j = Math.max(j, m);
                }
            }
            let n = new AxisRange(i, j);
            n = this.an(n, this.qe(), a);
            return n;
        }
        r8() {
            this.e1 = this.valueColumn == null || this.valueColumn.count == 0 ? NaN : this.valueColumn.item(this.valueColumn.count - 1);
        }
        get useHighMarkerFidelity() {
            return this.qp;
        }
    }
    AnchoredCategorySeries.$t = /*@__PURE__*/ markType(AnchoredCategorySeries, 'AnchoredCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasSingleValueCategory_$type, IHasCategoryTrendline_$type, ITrendLineSeries_$type]);
    AnchoredCategorySeries.r9 = /*@__PURE__*/ DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredCategorySeries.$, /*@__PURE__*/ new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
    AnchoredCategorySeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, AnchoredCategorySeries, 'raisePropertyChanged', ['ConsolidatedItemHitTestBehavior:rp:sa', [ConsolidatedItemHitTestBehavior_$type, /*@__PURE__*/ enumGetBox(ConsolidatedItemHitTestBehavior_$type, 0)], 'MarkerCollisionAvoidance:ro:sb', [CategorySeriesMarkerCollisionAvoidance_$type, /*@__PURE__*/ enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, 1)], 'ValueMemberPath:r2:sj', [2, null], 'TrendLineType::sh', [TrendLineType_$type, /*@__PURE__*/ enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::sg', [1, 1.5], 'TrendLinePeriod::sf', [1, 7], 'TrendLineBrush::sc', [Brush.$, null], 'TrendLineZIndex:rw:si', [1, 1001], 'TrendLineDashArray:sl:sd', [DoubleCollection.$], 'TrendLineDashCap:sm:se', [PenLineCap_$type, /*@__PURE__*/ enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredCategorySeries;
})();
/**
 * @hidden
 */
export let AnchoredCategoryBucketCalculator = /*@__PURE__*/ (() => {
    class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
        constructor(a) {
            super(a);
            this.i = null;
            this.h = null;
            this.j = 0;
            this.i = a;
        }
        getBucketWithoutUnknowns(a) {
            let b = this.h;
            let c = this.j;
            let d = a * this.d;
            let e = d + this.d - 1;
            let f = c - 1;
            d = d < f ? d : f;
            e = e < f ? e : f;
            let g = 1.7976931348623157E+308;
            let h = -1.7976931348623157E+308;
            let i = true;
            for (let j = d; j <= e; ++j) {
                let k = b[j];
                g = g < k ? g : k;
                h = h > k ? h : k;
                i = false;
            }
            if (!i) {
                return [0.5 * (d + e), g, h];
            }
            return [0.5 * (d + e), NaN, NaN];
        }
        getBucket(a) {
            let b = this.h;
            let c = this.j;
            let d = a * this.d;
            let e = d + this.d - 1;
            let f = c - 1;
            d = d < f ? d : f;
            e = e < f ? e : f;
            let g = 0;
            let h = 0;
            let i = true;
            for (let j = d; j <= e; ++j) {
                let k = b[j];
                if (!i) {
                    if (!isNaN_(k)) {
                        g = g < k ? g : k;
                        h = h > k ? h : k;
                    }
                }
                else {
                    if (!isNaN_(k)) {
                        g = k;
                        h = k;
                        i = false;
                    }
                }
            }
            if (!i) {
                return [0.5 * (d + e), g, h];
            }
            return [0.5 * (d + e), NaN, NaN];
        }
        cacheValues() {
            this.j = this.i.c0.valueColumn.count;
            this.h = this.i.c0.valueColumn.asArray();
        }
        unCacheValues() {
            this.h = null;
        }
    }
    AnchoredCategoryBucketCalculator.$t = /*@__PURE__*/ markType(AnchoredCategoryBucketCalculator, 'AnchoredCategoryBucketCalculator', CategoryBucketCalculator.$);
    return AnchoredCategoryBucketCalculator;
})();
/**
 * @hidden
 */
export let AnchoredCategorySeriesView = /*@__PURE__*/ (() => {
    class AnchoredCategorySeriesView extends CategorySeriesView {
        constructor(a) {
            super(a);
            this.c0 = null;
            this.c1 = null;
            this.c0 = a;
        }
        get c2() {
            if (this.c1 == null) {
                this.c1 = CategoryTrendLineManagerFactory.a(this.c1, this.e.aq(), this.e.ls, this.e, this.e.cg);
            }
            return this.c1;
        }
        set c2(a) {
            this.c1 = a;
        }
        get c3() {
            return this.c1 != null;
        }
        c7() {
            this.c0.sk = null;
        }
        c5() {
            this.c0.sk = this.c0.trendLineBrush;
        }
        c4() {
            this.c0.sk = this.c0.m9;
        }
        cs() {
            return new AnchoredCategoryBucketCalculator(this);
        }
        c6() {
            this.cr.cacheValues();
        }
        c8() {
            this.cr.unCacheValues();
        }
        c9(a) {
            let b = this.cu.item(a);
            return this.cp(b);
        }
        a5(a, b) {
            if (a.d) {
                if (this.c0.trendLineType != 0 && !b) {
                    let c = this.c2.g$j;
                    c.ac = this.c0.trendLineThickness;
                    c._stroke = this.c0.sk;
                    c.ai = this.c0.sl;
                    c.ad = this.c0.sm;
                    a.u(c);
                }
            }
            super.a5(a, b);
        }
        getDefaultTooltipTemplate() {
            return this.c0.rr.c$c(this.e, this.c0.r2);
        }
    }
    AnchoredCategorySeriesView.$t = /*@__PURE__*/ markType(AnchoredCategorySeriesView, 'AnchoredCategorySeriesView', CategorySeriesView.$);
    return AnchoredCategorySeriesView;
})();
//# sourceMappingURL=AnchoredCategorySeries_combined.js.map
