/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { DomainChart } from "./DomainChart";
import { fromEnum, enumGetBox, markType } from "igniteui-react-core";
import { HorizontalAlignment_$type } from "igniteui-react-core";
import { VerticalAlignment_$type } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { AxisLabelsLocation_$type } from "./AxisLabelsLocation";
import { AxisLabelSettings } from "./AxisLabelSettings";
import { TitleSettings } from "./TitleSettings";
import { ScalerParams } from "./ScalerParams";
/**
 * @hidden
 */
export let XYChart = /*@__PURE__*/ (() => {
    class XYChart extends DomainChart {
        constructor() {
            super(...arguments);
            this.jr = null;
            this.js = null;
            this.j4 = 0;
            this.j6 = 5;
            this.j5 = 0;
            this.j3 = 5;
            this.kl = 5;
            this.kn = 0;
            this.km = 5;
            this.kk = 0;
            this.o7 = null;
            this.pe = null;
            this.kf = 0;
            this.kw = 0;
            this.ke = NaN;
            this.kv = NaN;
            this.kh = NaN;
            this.ky = NaN;
            this.kg = NaN;
            this.kx = NaN;
            this.kd = NaN;
            this.ku = NaN;
            this.pd = null;
            this.pk = null;
            this.l6 = null;
            this.ma = null;
            this.l8 = null;
            this.mc = null;
            this.l1 = null;
            this.l2 = null;
            this.o8 = null;
            this.pf = null;
            this.j7 = 1;
            this.ko = 1;
            this.j8 = 1;
            this.kp = 0;
            this.pa = null;
            this.ph = null;
            this.pb = null;
            this.pi = null;
            this.j9 = 1;
            this.kq = 1;
            this.ka = 5;
            this.kr = 0;
            this.pc = null;
            this.pj = null;
            this.kb = 2;
            this.ks = 2;
            this.l7 = null;
            this.mb = null;
            this.o9 = null;
            this.pg = null;
            this.j2 = 0;
            this.kj = 0;
            this.j1 = NaN;
            this.ki = NaN;
            this.kc = 0;
            this.kt = -90;
            this.jx = false;
            this.jy = false;
            this.o2 = 1;
            this.p1 = 1;
            this.o1 = 1;
            this.o3 = 2;
            this.pz = 0;
            this.p0 = 1;
            this.p5 = 0;
            this.p6 = 0;
            this.jv = 2;
            this.l5 = null;
            this.jl = null;
            this.l9 = null;
            this.jm = null;
        }
        provideContainer(a) {
            if (a != null) {
                let b = this.jp();
                let c = this.jq();
                if (b != null) {
                    b.provideRenderer(a);
                }
                if (c != null) {
                    c.provideRenderer(a);
                }
            }
            super.provideContainer(a);
        }
        hs() {
            super.hs();
            let a = this.jp();
            let b = this.jq();
            if (a != null && a.ay != null) {
                this.pl = a.ay.textColor;
            }
            if (b != null && b.ay != null) {
                this.ps = b.ay.textColor;
            }
        }
        ie(a, b, c) {
            super.ie(a, b, c);
            switch (a) {
                case "XAxisLabelLeftMargin":
                    this.ov((d) => d.leftMargin = this.k6);
                    break;
                case "XAxisLabelTopMargin":
                    this.ov((d) => d.topMargin = this.k8);
                    break;
                case "XAxisLabelRightMargin":
                    this.ov((d) => d.rightMargin = this.k7);
                    break;
                case "XAxisLabelBottomMargin":
                    this.ov((d) => d.bottomMargin = this.k5);
                    break;
                case "YAxisLabelLeftMargin":
                    this.oz((d) => d.leftMargin = this.ln);
                    break;
                case "YAxisLabelTopMargin":
                    this.oz((d) => d.topMargin = this.lp);
                    break;
                case "YAxisLabelRightMargin":
                    this.oz((d) => d.rightMargin = this.lo);
                    break;
                case "YAxisLabelBottomMargin":
                    this.oz((d) => d.bottomMargin = this.lm);
                    break;
                case "XAxisLabelTextColor":
                    this.ov((d) => d.textColor = this.pl);
                    break;
                case "YAxisLabelTextColor":
                    this.oz((d) => d.textColor = this.ps);
                    break;
                case "XAxisTitleMargin":
                    this.ow((d) => d.margin = this.lh);
                    break;
                case "YAxisTitleMargin":
                    this.o0((d) => d.margin = this.ly);
                    break;
                case "XAxisTitleLeftMargin":
                    this.ow((d) => d.leftMargin = this.lg);
                    break;
                case "YAxisTitleLeftMargin":
                    this.o0((d) => d.leftMargin = this.lx);
                    break;
                case "XAxisTitleTopMargin":
                    this.ow((d) => d.topMargin = this.lj);
                    break;
                case "YAxisTitleTopMargin":
                    this.o0((d) => d.topMargin = this.l0);
                    break;
                case "XAxisTitleRightMargin":
                    this.ow((d) => d.rightMargin = this.li);
                    break;
                case "YAxisTitleRightMargin":
                    this.o0((d) => d.rightMargin = this.lz);
                    break;
                case "XAxisTitleBottomMargin":
                    this.ow((d) => d.bottomMargin = this.lf);
                    break;
                case "YAxisTitleBottomMargin":
                    this.o0((d) => d.bottomMargin = this.lw);
                    break;
                case "XAxisTitleTextColor":
                    this.ow((d) => d.textColor = this.pr);
                    break;
                case "YAxisTitleTextColor":
                    this.o0((d) => d.textColor = this.py);
                    break;
                case "XAxisFormatLabel":
                    this.ot((d) => d.at = this.jt);
                    break;
                case "YAxisFormatLabel":
                    this.ox((d) => d.at = this.ju);
                    break;
            }
        }
        get jt() {
            return this.jr;
        }
        set jt(a) {
            let b = this.jt;
            if (a != b) {
                this.jr = a;
                this.id("XAxisFormatLabel", b, this.jt);
            }
        }
        get ju() {
            return this.js;
        }
        set ju(a) {
            let b = this.ju;
            if (a != b) {
                this.js = a;
                this.id("YAxisFormatLabel", b, this.ju);
            }
        }
        get k6() {
            return this.j4;
        }
        set k6(a) {
            let b = this.k6;
            if (a != b) {
                this.j4 = a;
                this.id("XAxisLabelLeftMargin", b, this.k6);
            }
        }
        get k8() {
            return this.j6;
        }
        set k8(a) {
            let b = this.k8;
            if (a != b) {
                this.j6 = a;
                this.id("XAxisLabelTopMargin", b, this.k8);
            }
        }
        get k7() {
            return this.j5;
        }
        set k7(a) {
            let b = this.k7;
            if (a != b) {
                this.j5 = a;
                this.id("XAxisLabelRightMargin", b, this.k7);
            }
        }
        get k5() {
            return this.j3;
        }
        set k5(a) {
            let b = this.k5;
            if (a != b) {
                this.j3 = a;
                this.id("XAxisLabelBottomMargin", b, this.k5);
            }
        }
        get ln() {
            return this.kl;
        }
        set ln(a) {
            let b = this.ln;
            if (a != b) {
                this.kl = a;
                this.id("YAxisLabelLeftMargin", b, this.ln);
            }
        }
        get lp() {
            return this.kn;
        }
        set lp(a) {
            let b = this.lp;
            if (a != b) {
                this.kn = a;
                this.id("YAxisLabelTopMargin", b, this.lp);
            }
        }
        get lo() {
            return this.km;
        }
        set lo(a) {
            let b = this.lo;
            if (a != b) {
                this.km = a;
                this.id("YAxisLabelRightMargin", b, this.lo);
            }
        }
        get lm() {
            return this.kk;
        }
        set lm(a) {
            let b = this.lm;
            if (a != b) {
                this.kk = a;
                this.id("YAxisLabelBottomMargin", b, this.lm);
            }
        }
        get pl() {
            return this.o7;
        }
        set pl(a) {
            let b = this.pl;
            if (a != b) {
                this.o7 = a;
                this.id("XAxisLabelTextColor", b, this.pl);
            }
        }
        get ps() {
            return this.pe;
        }
        set ps(a) {
            let b = this.ps;
            if (a != b) {
                this.pe = a;
                this.id("YAxisLabelTextColor", b, this.ps);
            }
        }
        get lh() {
            return this.kf;
        }
        set lh(a) {
            let b = this.lh;
            if (a != b) {
                this.kf = a;
                this.id("XAxisTitleMargin", b, this.lh);
            }
        }
        get ly() {
            return this.kw;
        }
        set ly(a) {
            let b = this.ly;
            if (a != b) {
                this.kw = a;
                this.id("YAxisTitleMargin", b, this.ly);
            }
        }
        get lg() {
            return this.ke;
        }
        set lg(a) {
            let b = this.lg;
            if (a != b) {
                this.ke = a;
                this.id("XAxisTitleLeftMargin", b, this.lg);
            }
        }
        get lx() {
            return this.kv;
        }
        set lx(a) {
            let b = this.lx;
            if (a != b) {
                this.kv = a;
                this.id("YAxisTitleLeftMargin", b, this.lx);
            }
        }
        get lj() {
            return this.kh;
        }
        set lj(a) {
            let b = this.lj;
            if (a != b) {
                this.kh = a;
                this.id("XAxisTitleTopMargin", b, this.lj);
            }
        }
        get l0() {
            return this.ky;
        }
        set l0(a) {
            let b = this.l0;
            if (a != b) {
                this.ky = a;
                this.id("YAxisTitleTopMargin", b, this.l0);
            }
        }
        get li() {
            return this.kg;
        }
        set li(a) {
            let b = this.li;
            if (a != b) {
                this.kg = a;
                this.id("XAxisTitleRightMargin", b, this.li);
            }
        }
        get lz() {
            return this.kx;
        }
        set lz(a) {
            let b = this.lz;
            if (a != b) {
                this.kx = a;
                this.id("YAxisTitleRightMargin", b, this.lz);
            }
        }
        get lf() {
            return this.kd;
        }
        set lf(a) {
            let b = this.lf;
            if (a != b) {
                this.kd = a;
                this.id("XAxisTitleBottomMargin", b, this.lf);
            }
        }
        get lw() {
            return this.ku;
        }
        set lw(a) {
            let b = this.lw;
            if (a != b) {
                this.ku = a;
                this.id("YAxisTitleBottomMargin", b, this.lw);
            }
        }
        get pr() {
            return this.pd;
        }
        set pr(a) {
            let b = this.pr;
            if (a != b) {
                this.pd = a;
                this.id("XAxisTitleTextColor", b, this.pr);
            }
        }
        get py() {
            return this.pk;
        }
        set py(a) {
            let b = this.py;
            if (a != b) {
                this.pk = a;
                this.id("YAxisTitleTextColor", b, this.py);
            }
        }
        ig(a, b, c) {
            super.ig(a, b, c);
            switch (a) {
                case "XAxisLabelTextStyle":
                    this.ov((d) => d.textStyle = this.mr);
                    break;
                case "YAxisLabelTextStyle":
                    this.oz((d) => d.textStyle = this.nw);
                    break;
                case "XAxisTitleTextStyle":
                    this.ow((d) => d.textStyle = this.nf);
                    break;
                case "YAxisTitleTextStyle":
                    this.o0((d) => d.textStyle = this.ok);
                    break;
            }
        }
        get mr() {
            return this.l6;
        }
        set mr(a) {
            let b = this.mr;
            if (a != b) {
                this.l6 = a;
                this.id("XAxisLabelTextStyle", b, this.mr);
            }
        }
        get nw() {
            return this.ma;
        }
        set nw(a) {
            let b = this.nw;
            if (a != b) {
                this.ma = a;
                this.id("YAxisLabelTextStyle", b, this.nw);
            }
        }
        get nf() {
            return this.l8;
        }
        set nf(a) {
            let b = this.nf;
            if (a != b) {
                this.l8 = a;
                this.id("XAxisTitleTextStyle", b, this.nf);
            }
        }
        get ok() {
            return this.mc;
        }
        set ok(a) {
            let b = this.ok;
            if (a != b) {
                this.mc = a;
                this.id("YAxisTitleTextStyle", b, this.ok);
            }
        }
        oq(a) {
            this.on(a, (b) => b.leftMargin = this.k6);
            this.on(a, (b) => b.topMargin = this.k8);
            this.on(a, (b) => b.rightMargin = this.k7);
            this.on(a, (b) => b.bottomMargin = this.k5);
            this.on(a, (b) => b.textColor = this.pl);
            this.oo(a, (b) => b.textColor = this.pr);
            this.oo(a, (b) => b.leftMargin = this.lg);
            this.oo(a, (b) => b.topMargin = this.lj);
            this.oo(a, (b) => b.rightMargin = this.li);
            this.oo(a, (b) => b.bottomMargin = this.lf);
            this.on(a, (b) => b.textStyle = this.mr);
            this.oo(a, (b) => b.textStyle = this.nf);
        }
        os(a) {
            this.on(a, (b) => b.leftMargin = this.ln);
            this.on(a, (b) => b.topMargin = this.lp);
            this.on(a, (b) => b.rightMargin = this.lo);
            this.on(a, (b) => b.bottomMargin = this.lm);
            this.on(a, (b) => b.textColor = this.ps);
            this.oo(a, (b) => b.textColor = this.py);
            this.oo(a, (b) => b.leftMargin = this.lx);
            this.oo(a, (b) => b.topMargin = this.l0);
            this.oo(a, (b) => b.rightMargin = this.lz);
            this.oo(a, (b) => b.bottomMargin = this.lw);
            this.on(a, (b) => b.textStyle = this.nw);
            this.oo(a, (b) => b.textStyle = this.ok);
        }
        iw(a) {
            let b = this.w(a);
            let c = this.ay(a, b);
            if (c == null) {
                return;
            }
            c.itemsSource = a.data;
            c.name = this.fi(a);
            c.gy = this.fj(a, b);
            this.dataChart.series.add(c);
        }
        ot(a) {
            this.ou(a, null);
        }
        ou(a, b) {
            a(this.jp());
        }
        oy(a, b) {
            a(this.jq());
        }
        ox(a) {
            this.oy(a, true);
        }
        ow(a) {
            this.oo(this.jp(), a);
        }
        o0(a) {
            this.oo(this.jq(), a);
        }
        oz(a) {
            this.on(this.jq(), a);
        }
        ov(a) {
            this.on(this.jp(), a);
        }
        kz(a) {
            let b = this.jp();
            return b.dz(a, new ScalerParams(1, this.jk, this.jj, b.ca));
        }
        k1(a) {
            let b = this.jp();
            return b.d2(a, new ScalerParams(1, this.jk, this.jj, b.ca));
        }
        k0(a) {
            let b = this.jq();
            return b.dz(a, new ScalerParams(1, this.jk, this.jj, b.ca));
        }
        k2(a) {
            let b = this.jq();
            return b.d2(a, new ScalerParams(1, this.jk, this.jj, b.ca));
        }
        iu(a) {
            super.iu(a);
            if (a == null) {
                return;
            }
            if (a.axes != null) {
                let b = this.jp();
                let c = this.jq();
                if (a.axes.contains(b)) {
                    a.axes.remove(b);
                }
                if (a.axes.contains(c)) {
                    a.axes.remove(c);
                }
            }
        }
        static md(a, b) {
            for (let c of fromEnum(b)) {
                let d = c.findMatchingHint(16);
                if (d != null) {
                    let e = d.path;
                    return e;
                }
            }
            return null;
        }
        hn(a) {
            super.hn(a);
            if (a == this.dataChart) {
                this.dataChart.axes.add(this.jp());
                this.dataChart.axes.add(this.jq());
            }
        }
        op(a) {
            if (a != null && this.ed != null && a.ev == null) {
                a.provideRenderer(this.ed);
            }
            a.it = this.pm;
            a.d6 = this.k9;
            a.iu = this.pn;
            a.d9 = this.la;
            a.iw = this.pp;
            a.eq = this.lb;
            a.iv = this.po;
            a.er = this.lc;
            a.ix = this.pq;
            a.es = this.ld;
            a.cq = true;
            let b = a == this.jp();
            if (b) {
                a.gd = this.m6;
            }
            a.fa = this.l3;
            a.fp = this.mj;
            a.ag = this.jn;
            this.on(a, (c) => c.angle = this.k4);
            this.on(a, (c) => {
                if (c.extent != this.k3) {
                    c.extent = this.k3;
                }
            });
            this.on(a, (c) => c.horizontalAlignment = this.o4);
            this.on(a, (c) => c.verticalAlignment = this.p2);
            this.on(a, (c) => c.visibility = this.p7);
            this.oo(a, (c) => c.horizontalAlignment = this.o5);
            this.oo(a, (c) => c.angle = this.le);
            this.oq(a);
        }
        or(a) {
            if (a == null) {
                return;
            }
            if (this.ed != null && a.ev == null) {
                a.provideRenderer(this.ed);
            }
            this.on(a, (b) => b.angle = this.ll);
            this.on(a, (b) => {
                if (b.extent != this.lk) {
                    b.extent = this.lk;
                }
            });
            this.on(a, (b) => b.horizontalAlignment = this.o6);
            this.on(a, (b) => b.verticalAlignment = this.p3);
            this.on(a, (b) => b.visibility = this.p8);
            this.on(a, (b) => b.location = this.jw);
            this.oo(a, (b) => b.verticalAlignment = this.p4);
            this.oo(a, (b) => b.angle = this.lv);
            a.it = this.pt;
            a.d6 = this.lq;
            a.iu = this.pu;
            a.d9 = this.lr;
            a.iw = this.pw;
            a.eq = this.ls;
            a.iv = this.pv;
            a.er = this.lt;
            a.ix = this.px;
            a.es = this.lu;
            let b = a == this.jq();
            if (b) {
                a.gd = this.ob;
            }
            a.fp = this.nn;
            a.ag = this.jo;
            this.os(a);
        }
        hk() {
            super.hk();
            this.op(this.jp());
            this.or(this.jq());
        }
        on(a, b) {
            if (a == null) {
                return;
            }
            if (a.ay == null) {
                a.ay = new AxisLabelSettings();
                a.ay.angle = a.dn();
                a.ay.bottomMargin = a.dp();
                a.ay.leftMargin = a.dq();
                a.ay.rightMargin = a.dr();
                a.ay.topMargin = a.ds();
                a.ay.horizontalAlignment = a.io();
                a.ay.location = a.az();
                a.ay.verticalAlignment = a.jh();
            }
            b(a.ay);
        }
        oo(a, b) {
            if (a == null) {
                return;
            }
            if (a.be == null) {
                a.be = new TitleSettings();
                a.be.bottomMargin = a.du();
                a.be.leftMargin = a.dv();
                a.be.rightMargin = a.dw();
                a.be.topMargin = a.dx();
                a.be.location = a.a0();
                a.be.angle = a.dt();
                a.be.horizontalAlignment = a.ip();
                a.be.verticalAlignment = a.ji();
            }
            b(a.be);
        }
        id(a, b, c) {
            super.id(a, b, c);
            switch (a) {
                case "XAxisLabelAngle":
                    this.ov((d) => d.angle = this.k4);
                    break;
                case "YAxisLabelAngle":
                    this.oz((d) => d.angle = this.ll);
                    break;
                case "XAxisLabelHorizontalAlignment":
                    this.ov((d) => d.horizontalAlignment = this.o4);
                    break;
                case "YAxisLabelHorizontalAlignment":
                    this.oz((d) => d.horizontalAlignment = this.o6);
                    break;
                case "XAxisLabelVerticalAlignment":
                    this.ov((d) => d.verticalAlignment = this.p2);
                    break;
                case "YAxisLabelVerticalAlignment":
                    this.oz((d) => d.verticalAlignment = this.p3);
                    break;
                case "XAxisLabelVisibility":
                    this.ov((d) => d.visibility = this.p7);
                    break;
                case "YAxisLabelVisibility":
                    this.oz((d) => d.visibility = this.p8);
                    break;
                case "XAxisLabel":
                    this.ot((d) => d.fa = this.l3);
                    break;
                case "YAxisLabel":
                    this.ox((d) => d.fa = this.l4);
                    break;
                case "XAxisLabelFormat":
                    this.ot((d) => d.fp = this.mj);
                    break;
                case "XAxisLabelFormatSpecifiers":
                    this.ot((d) => d.ag = this.jn);
                    break;
                case "YAxisLabelFormat":
                    this.ox((d) => d.fp = this.nn);
                    break;
                case "YAxisLabelFormatSpecifiers":
                    this.ox((d) => d.ag = this.jo);
                    break;
                case "XAxisTitleAngle":
                    this.ow((d) => d.angle = this.le);
                    break;
                case "YAxisTitleAngle":
                    this.o0((d) => d.angle = this.lv);
                    break;
                case "XAxisTitleAlignment":
                    this.ow((d) => d.horizontalAlignment = this.o5);
                    break;
                case "YAxisTitleAlignment":
                    this.o0((d) => d.verticalAlignment = this.p4);
                    break;
                case "XAxisTitle":
                    this.ot((d) => d.gd = this.m6);
                    break;
                case "YAxisTitle":
                    this.oy((d) => d.gd = this.ob, false);
                    break;
                case "XAxisMajorStroke":
                    this.ou((d) => d.it = this.pm, a);
                    break;
                case "YAxisMajorStroke":
                    this.ox((d) => d.it = this.pt);
                    break;
                case "XAxisMajorStrokeThickness":
                    this.ou((d) => d.d6 = this.k9, a);
                    break;
                case "YAxisMajorStrokeThickness":
                    this.ox((d) => d.d6 = this.lq);
                    break;
                case "XAxisMinorStroke":
                    this.ot((d) => d.iu = this.pn);
                    break;
                case "YAxisMinorStroke":
                    this.ox((d) => d.iu = this.pu);
                    break;
                case "XAxisMinorStrokeThickness":
                    this.ot((d) => d.d9 = this.la);
                    break;
                case "YAxisMinorStrokeThickness":
                    this.ox((d) => d.d9 = this.lr);
                    break;
                case "XAxisTickLength":
                    this.ot((d) => d.er = this.lc);
                    break;
                case "YAxisTickLength":
                    this.ox((d) => d.er = this.lt);
                    break;
                case "XAxisTickStroke":
                    this.ot((d) => d.ix = this.pq);
                    break;
                case "YAxisTickStroke":
                    this.ox((d) => d.ix = this.px);
                    break;
                case "XAxisTickStrokeThickness":
                    this.ot((d) => d.es = this.ld);
                    break;
                case "YAxisTickStrokeThickness":
                    this.ox((d) => d.es = this.lu);
                    break;
                case "XAxisStroke":
                    this.ot((d) => d.iw = this.pp);
                    break;
                case "YAxisStroke":
                    this.ox((d) => d.iw = this.pw);
                    break;
                case "XAxisStrokeThickness":
                    this.ot((d) => d.eq = this.lb);
                    break;
                case "YAxisStrokeThickness":
                    this.ox((d) => d.eq = this.ls);
                    break;
                case "XAxisExtent":
                    this.ov((d) => d.extent = this.k3);
                    break;
                case "YAxisExtent":
                    this.oz((d) => d.extent = this.lk);
                    break;
                case "XAxisStrip":
                    this.ot((d) => d.iv = this.po);
                    break;
                case "YAxisStrip":
                    this.ox((d) => d.iv = this.pv);
                    break;
                case "XAxisInverted":
                    this.ot((d) => d.ca = this.jz);
                    break;
                case "YAxisInverted":
                    this.ox((d) => d.ca = this.j0);
                    break;
                case "YAxisLabelLocation":
                    this.oz((d) => d.location = this.jw);
                    break;
            }
        }
        get l3() {
            return this.l1;
        }
        set l3(a) {
            let b = this.l3;
            if (a != b) {
                this.l1 = a;
                this.id("XAxisLabel", b, this.l3);
            }
        }
        get l4() {
            return this.l2;
        }
        set l4(a) {
            let b = this.l4;
            if (a != b) {
                this.l2 = a;
                this.id("YAxisLabel", b, this.l4);
            }
        }
        get pm() {
            return this.o8;
        }
        set pm(a) {
            let b = this.pm;
            if (a != b) {
                this.o8 = a;
                this.id("XAxisMajorStroke", b, this.pm);
            }
        }
        get pt() {
            return this.pf;
        }
        set pt(a) {
            let b = this.pt;
            if (a != b) {
                this.pf = a;
                this.id("YAxisMajorStroke", b, this.pt);
            }
        }
        get k9() {
            return this.j7;
        }
        set k9(a) {
            let b = this.k9;
            if (a != b) {
                this.j7 = a;
                this.id("XAxisMajorStrokeThickness", b, this.k9);
            }
        }
        get lq() {
            return this.ko;
        }
        set lq(a) {
            let b = this.lq;
            if (a != b) {
                this.ko = a;
                this.id("YAxisMajorStrokeThickness", b, this.lq);
            }
        }
        get la() {
            return this.j8;
        }
        set la(a) {
            let b = this.la;
            if (a != b) {
                this.j8 = a;
                this.id("XAxisMinorStrokeThickness", b, this.la);
            }
        }
        get lr() {
            return this.kp;
        }
        set lr(a) {
            let b = this.lr;
            if (a != b) {
                this.kp = a;
                this.id("YAxisMinorStrokeThickness", b, this.lr);
            }
        }
        get po() {
            return this.pa;
        }
        set po(a) {
            let b = this.po;
            if (a != b) {
                this.pa = a;
                this.id("XAxisStrip", b, this.po);
            }
        }
        get pv() {
            return this.ph;
        }
        set pv(a) {
            let b = this.pv;
            if (a != b) {
                this.ph = a;
                this.id("YAxisStrip", b, this.pv);
            }
        }
        get pp() {
            return this.pb;
        }
        set pp(a) {
            let b = this.pp;
            if (a != b) {
                this.pb = a;
                this.id("XAxisStroke", b, this.pp);
            }
        }
        get pw() {
            return this.pi;
        }
        set pw(a) {
            let b = this.pw;
            if (a != b) {
                this.pi = a;
                this.id("YAxisStroke", b, this.pw);
            }
        }
        get lb() {
            return this.j9;
        }
        set lb(a) {
            let b = this.lb;
            if (a != b) {
                this.j9 = a;
                this.id("XAxisStrokeThickness", b, this.lb);
            }
        }
        get ls() {
            return this.kq;
        }
        set ls(a) {
            let b = this.ls;
            if (a != b) {
                this.kq = a;
                this.id("YAxisStrokeThickness", b, this.ls);
            }
        }
        get lc() {
            return this.ka;
        }
        set lc(a) {
            let b = this.lc;
            if (a != b) {
                this.ka = a;
                this.id("XAxisTickLength", b, this.lc);
            }
        }
        get lt() {
            return this.kr;
        }
        set lt(a) {
            let b = this.lt;
            if (a != b) {
                this.kr = a;
                this.id("YAxisTickLength", b, this.lt);
            }
        }
        get pq() {
            return this.pc;
        }
        set pq(a) {
            let b = this.pq;
            if (a != b) {
                this.pc = a;
                this.id("XAxisTickStroke", b, this.pq);
            }
        }
        get px() {
            return this.pj;
        }
        set px(a) {
            let b = this.px;
            if (a != b) {
                this.pj = a;
                this.id("YAxisTickStroke", b, this.px);
            }
        }
        get ld() {
            return this.kb;
        }
        set ld(a) {
            let b = this.ld;
            if (a != b) {
                this.kb = a;
                this.id("XAxisTickStrokeThickness", b, this.ld);
            }
        }
        get lu() {
            return this.ks;
        }
        set lu(a) {
            let b = this.lu;
            if (a != b) {
                this.ks = a;
                this.id("YAxisTickStrokeThickness", b, this.lu);
            }
        }
        get m6() {
            return this.l7;
        }
        set m6(a) {
            let b = this.m6;
            if (a != b) {
                this.l7 = a;
                this.id("XAxisTitle", b, this.m6);
            }
        }
        get ob() {
            return this.mb;
        }
        set ob(a) {
            let b = this.ob;
            if (a != b) {
                this.mb = a;
                this.id("YAxisTitle", b, this.ob);
            }
        }
        get pn() {
            return this.o9;
        }
        set pn(a) {
            let b = this.pn;
            if (a != b) {
                this.o9 = a;
                this.id("XAxisMinorStroke", b, this.pn);
            }
        }
        get pu() {
            return this.pg;
        }
        set pu(a) {
            let b = this.pu;
            if (a != b) {
                this.pg = a;
                this.id("YAxisMinorStroke", b, this.pu);
            }
        }
        get k4() {
            return this.j2;
        }
        set k4(a) {
            let b = this.k4;
            if (a != b) {
                this.j2 = a;
                this.id("XAxisLabelAngle", b, this.k4);
            }
        }
        get ll() {
            return this.kj;
        }
        set ll(a) {
            let b = this.ll;
            if (a != b) {
                this.kj = a;
                this.id("YAxisLabelAngle", b, this.ll);
            }
        }
        get k3() {
            return this.j1;
        }
        set k3(a) {
            let b = this.k3;
            if (a != b) {
                this.j1 = a;
                this.id("XAxisExtent", b, this.k3);
            }
        }
        get lk() {
            return this.ki;
        }
        set lk(a) {
            let b = this.lk;
            if (a != b) {
                this.ki = a;
                this.id("YAxisExtent", b, this.lk);
            }
        }
        get le() {
            return this.kc;
        }
        set le(a) {
            let b = this.le;
            if (a != b) {
                this.kc = a;
                this.id("XAxisTitleAngle", b, this.le);
            }
        }
        get lv() {
            return this.kt;
        }
        set lv(a) {
            let b = this.lv;
            if (a != b) {
                this.kt = a;
                this.id("YAxisTitleAngle", b, this.lv);
            }
        }
        get jz() {
            return this.jx;
        }
        set jz(a) {
            let b = this.jz;
            if (a != b) {
                this.jx = a;
                this.id("XAxisInverted", b, this.jz);
            }
        }
        get j0() {
            return this.jy;
        }
        set j0(a) {
            let b = this.j0;
            if (a != b) {
                this.jy = a;
                this.id("YAxisInverted", b, this.j0);
            }
        }
        get o5() {
            return this.o2;
        }
        set o5(a) {
            let b = this.o5;
            if (a != b) {
                this.o2 = a;
                this.id("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.o5));
            }
        }
        get p4() {
            return this.p1;
        }
        set p4(a) {
            let b = this.p4;
            if (a != b) {
                this.p1 = a;
                this.id("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.p4));
            }
        }
        get o4() {
            return this.o1;
        }
        set o4(a) {
            let b = this.o4;
            if (a != b) {
                this.o1 = a;
                this.id("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.o4));
            }
        }
        get_o6() {
            return this.o3;
        }
        set_o6(a) {
            let b = this.o6;
            if (a != b) {
                this.o3 = a;
                this.id("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.o6));
            }
        }
        get o6() {
            return this.get_o6();
        }
        set o6(a) {
            this.set_o6(a);
        }
        get p2() {
            return this.pz;
        }
        set p2(a) {
            let b = this.p2;
            if (a != b) {
                this.pz = a;
                this.id("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.p2));
            }
        }
        get p3() {
            return this.p0;
        }
        set p3(a) {
            let b = this.p3;
            if (a != b) {
                this.p0 = a;
                this.id("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.p3));
            }
        }
        get p7() {
            return this.p5;
        }
        set p7(a) {
            let b = this.p7;
            if (a != b) {
                this.p5 = a;
                this.id("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.p7));
            }
        }
        get p8() {
            return this.p6;
        }
        set p8(a) {
            let b = this.p8;
            if (a != b) {
                this.p6 = a;
                this.id("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.p8));
            }
        }
        get_jw() {
            return this.jv;
        }
        set_jw(a) {
            let b = this.jw;
            if (a != b) {
                this.jv = a;
                this.id("YAxisLabelLocation", enumGetBox(AxisLabelsLocation_$type, b), enumGetBox(AxisLabelsLocation_$type, this.jw));
            }
        }
        get jw() {
            return this.get_jw();
        }
        set jw(a) {
            this.set_jw(a);
        }
        get mj() {
            return this.l5;
        }
        set mj(a) {
            let b = this.l5;
            if (a != b) {
                this.l5 = a;
                this.id("XAxisLabelFormat", b, this.l5);
            }
        }
        get jn() {
            return this.jl;
        }
        set jn(a) {
            let b = this.jl;
            if (a != b) {
                this.jl = a;
                this.id("XAxisLabelFormatSpecifiers", b, this.jl);
            }
        }
        get nn() {
            return this.l9;
        }
        set nn(a) {
            let b = this.l9;
            if (a != b) {
                this.l9 = a;
                this.id("YAxisLabelFormat", b, this.l9);
            }
        }
        get jo() {
            return this.jm;
        }
        set jo(a) {
            let b = this.jm;
            if (a != b) {
                this.jm = a;
                this.id("YAxisLabelFormatSpecifiers", b, this.jm);
            }
        }
    }
    XYChart.$t = /*@__PURE__*/ markType(XYChart, 'XYChart', DomainChart.$);
    return XYChart;
})();
//# sourceMappingURL=XYChart.js.map
