import { UnknownValuePlotting_$type } from "igniteui-react-core";
import { IgrAnchoredRadialSeries } from "./igr-anchored-radial-series";
import { RadialAreaSeries } from "./RadialAreaSeries";
import { ensureEnum } from "igniteui-react-core";
/**
 * Represents a IgxDataChartComponent radial area series.
*/
export class IgrRadialAreaSeries extends IgrAnchoredRadialSeries {
    createImplementation() {
        return new RadialAreaSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor(props) {
        super(props);
    }
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    get unknownValuePlotting() {
        return this.i.r7;
    }
    set unknownValuePlotting(v) {
        this.i.r7 = ensureEnum(UnknownValuePlotting_$type, v);
    }
}
//# sourceMappingURL=igr-radial-area-series.js.map
