import * as tslib_1 from "tslib";
import { IgrAssigningSeriesShapeStyleEventArgsBase } from "./igr-assigning-series-shape-style-event-args-base";
import { AssigningCategoryStyleEventArgs as AssigningCategoryStyleEventArgs_internal } from "./AssigningCategoryStyleEventArgs";
/**
 * Represents event arguments class for the AssigningCategoryStyleEvent
*
* The `AssigningCategoryStyle` event fired to allow you to override the style of items in a category or financial series
*
* ```ts
* <IgrDataChart
*     dataSource={this.state.dataSource}
*     width="700px"
*     height="500px">
*
*     <IgrCategoryXAxis name="xAxis" label="Year" />
*     <IgrNumericYAxis  name="yAxis" />
*
*     <IgrRangeColumnSeries
*         name="series1"
*         xAxisName="xAxis"
*         yAxisName="yAxis"
*         highMemberPath="High"
*         lowMemberPath="Low"
* 		isCustomCategoryStyleAllowed="true"
* 		assigningCategoryMarkerStyle= {this.onAssigningCategoryStyle} />
*  </IgrDataChart>
* ```
*
* ```ts
*  series1.assigningCategoryStyle = this.onAssigningCategoryStyle ;
*  public onAssigningCategoryStyle =( s:IgrCategorySeries , e: AssigningCategoryStyleEventArgs) => {
*
*   }
* ```
*/
var IgrAssigningCategoryStyleEventArgs = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(IgrAssigningCategoryStyleEventArgs, _super);
    function IgrAssigningCategoryStyleEventArgs() {
        return _super.call(this) || this;
    }
    IgrAssigningCategoryStyleEventArgs.prototype.createImplementation = function () {
        return new AssigningCategoryStyleEventArgs_internal();
    };
    Object.defineProperty(IgrAssigningCategoryStyleEventArgs.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    return IgrAssigningCategoryStyleEventArgs;
}(IgrAssigningSeriesShapeStyleEventArgsBase));
export { IgrAssigningCategoryStyleEventArgs };
//# sourceMappingURL=igr-assigning-category-style-event-args.js.map
