import * as tslib_1 from "tslib";
import { TreemapNodeStyleMappingTargetType_$type } from "./TreemapNodeStyleMappingTargetType";
import { TreemapValueMappingMode_$type } from "./TreemapValueMappingMode";
import { IgrTreemapNodeStyle } from "./igr-treemap-node-style";
import { TreemapNodeStyleMapping } from "./TreemapNodeStyleMapping";
import { ensureEnum } from "igniteui-react-core";
/**
 * Represents a style to apply to a set of nodes in the treemap.
*/
var IgrTreemapNodeStyleMapping = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(IgrTreemapNodeStyleMapping, _super);
    function IgrTreemapNodeStyleMapping(props) {
        return _super.call(this, props) || this;
    }
    IgrTreemapNodeStyleMapping.prototype.createImplementation = function () {
        return new TreemapNodeStyleMapping();
    };
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "targetType", {
        /**
         * Gets or sets the unique name of the mapping.
        */
        get: function () {
            return this.i.bf;
        },
        set: function (v) {
            this.i.bf = ensureEnum(TreemapNodeStyleMappingTargetType_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "name", {
        /**
         * Gets or sets the unique name of the mapping.
        */
        get: function () {
            return this.i.bs;
        },
        set: function (v) {
            this.i.bs = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "minimumValue", {
        /**
         * Gets or sets the minimum value to which the mapping applies.
        */
        get: function () {
            return this.i.bl;
        },
        set: function (v) {
            this.i.bl = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "maximumValue", {
        /**
         * Gets or sets the maximum value to which the mapping applies.
        */
        get: function () {
            return this.i.bk;
        },
        set: function (v) {
            this.i.bk = +v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "value", {
        /**
         * Gets or sets the value to which the mapping applies.
        */
        get: function () {
            return this.i.bn;
        },
        set: function (v) {
            this.i.bn = v;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgrTreemapNodeStyleMapping.prototype, "mappingMode", {
        /**
         * Gets or sets the mapping mode to use to evaluate whether the mapping applies.
        */
        get: function () {
            return this.i.bh;
        },
        set: function (v) {
            this.i.bh = ensureEnum(TreemapValueMappingMode_$type, v);
        },
        enumerable: true,
        configurable: true
    });
    return IgrTreemapNodeStyleMapping;
}(IgrTreemapNodeStyle));
export { IgrTreemapNodeStyleMapping };
//# sourceMappingURL=igr-treemap-node-style-mapping.js.map
