import { Type } from "igniteui-react-core";
/**
 * Describes available orientations for an axis.
 */
export declare enum AxisOrientation {
    /**
     * Specifies a horizontal axis.
     */
    Horizontal = 0,
    /**
     * Specifies a vertical axis.
     */
    Vertical = 1,
    /**
     * Specifies an angular axis used by the polar series.
     */
    Angular = 2,
    /**
     * Specifies a radial axis used by radial series.
     */
    Radial = 3
}
/**
 * @hidden
 */
export declare let AxisOrientation_$type: Type;
