import { Type } from "igniteui-react-core";
/**
 * Describes available locations of the axis labels in the chart.
 */
export declare enum MarkerOutlineMode {
    /**
     * Outline mode is managed by the series.
     */
    Auto = 0,
    /**
     * This series base its marker brush on the marker outlines collection.
     */
    Normal = 1,
    /**
     * The series should match the marker outline to the marker brush.
     */
    MatchMarkerBrush = 2
}
/**
 * @hidden
 */
export declare let MarkerOutlineMode_$type: Type;
