import { IgrStrategyBasedIndicator, IIgrStrategyBasedIndicatorProps } from "./igr-strategy-based-indicator";
import { MassIndexIndicator } from "./MassIndexIndicator";
/**
 * Represents a IgxDataChartComponent Mass Index indicator series.
 * Default required members: High, Low
*
* Represents a Ignite UIDataChart Mass Index indicator series.
*
* Example:
*
* ```ts
*  <IgrDataChart
*     dataSource={this.state.dataSource} >
*
*     <IgrCategoryXAxis name="xAxis" />
*     <IgrNumericYAxis name="yAxis" />
*
*     <IgrMassIndexIndicator
* 	name="series1"
* 	volumeMemberPath="Volume"
* 	highMemberPath="High"
* 	lowMemberPath="Low"/>
*  </IgrDataChart>
* ```
*
* ```ts
* this.series = new IgrMassIndexIndicator ({ name: "Series1" });
* this.series.dataSource = this.data;
* this.series.xAxis = this.categoryXAxis;
* this.series.yAxis = this.numericYAxis;
* this.series.xAxisName = "categoryXAxis";
* this.series.yAxisName = "numericYAxis";
* this.series.volumeMemberPath="Volume" ;
* this.series.highMemberPath= "High" ;
* this.series.lowMemberPath="Low" ;
* ```
*/
export declare class IgrMassIndexIndicator extends IgrStrategyBasedIndicator<IIgrMassIndexIndicatorProps> {
    protected createImplementation(): MassIndexIndicator;
    /**
                                 * @hidden
                                 */
    readonly i: MassIndexIndicator;
    constructor(props: IIgrMassIndexIndicatorProps);
}
export interface IIgrMassIndexIndicatorProps extends IIgrStrategyBasedIndicatorProps {
}
