import { IgrRing } from "./igr-ring";
import { IgrRingSeriesBase } from "./igr-ring-series-base";
import { RingSeries } from "./RingSeries";
import { IgrIndexCollection } from "./igr-index-collection";
import { IIgrRingSeriesBaseProps } from "./igr-ring-series-base";
/**
 * Represents one ring in IgxDoughnutChartComponent series.
*/
export declare class IgrRingSeries extends IgrRingSeriesBase<IIgrRingSeriesProps> {
    protected createImplementation(): RingSeries;
    readonly i: RingSeries;
    constructor(props: IIgrRingSeriesProps);
    private _explodedSlices;
    /**
     * Gets or sets the collection of exploded slice indices.
    */
    explodedSlices: IgrIndexCollection;
    private _selectedSlices;
    /**
     * Gets or sets the collection of selected slice indices.
    */
    selectedSlices: IgrIndexCollection;
    sychronizeCollections(): void;
    /**
 * Gets reference to the ring data.
*/
    ring: IgrRing;
    findByName(name: string): any;
}
export interface IIgrRingSeriesProps extends IIgrRingSeriesBaseProps {
    selectedSlices?: IgrIndexCollection;
    explodedSlices?: IgrIndexCollection;
    /**
 * Gets reference to the ring data.
*/
    ring?: IgrRing;
}
