import * as React from 'react';
import { IgrPropertyUpdatedEventArgs } from "igniteui-react-core";
import { SizeScale } from "./SizeScale";
/**
 * Represents a scale that is used determine an object's size.
*/
export declare class IgrSizeScale<P extends IIgrSizeScaleProps = IIgrSizeScaleProps> extends React.Component<P, {}> {
    protected createImplementation(): SizeScale;
    protected _implementation: any;
    /**
     * @hidden
     */
    readonly i: SizeScale; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrSizeScale;
    private onImplementationCreated;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): any;
    /**
     * Gets or sets global minimum value that will be mapped to MinumumValue of this scale
    */
    globalMinimum: number;
    /**
     * Gets or sets global maximum value that will be mapped to MaxumumValue of this scale
    */
    globalMaximum: number;
    /**
     * Gets or sets the minimum size (in pixels) for this scale.
    */
    minimumValue: number;
    /**
     * Gets or sets the maximum size (in pixels) for this scale.
    */
    maximumValue: number;
    /**
     * Gets or sets whether the scale is logarithmic.
    */
    isLogarithmic: boolean;
    /**
     * Gets or sets the logarithm base for this scale.
    */
    logarithmBase: number;
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected readonly hasUserValues: Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    getCurrentGlobalMinimum(): number;
    getCurrentGlobalMaximum(): number;
    private _propertyUpdated;
    private _propertyUpdated_wrapped;
    /**
     * Event raised when a property (including "effective" and non-dependency property) value changes.
    */
    propertyUpdated: (s: IgrSizeScale, e: IgrPropertyUpdatedEventArgs) => void;
}
export interface IIgrSizeScaleProps {
    /**
     * Gets or sets global minimum value that will be mapped to MinumumValue of this scale
    */
    globalMinimum?: number | string;
    /**
     * Gets or sets global maximum value that will be mapped to MaxumumValue of this scale
    */
    globalMaximum?: number | string;
    /**
     * Gets or sets the minimum size (in pixels) for this scale.
    */
    minimumValue?: number | string;
    /**
     * Gets or sets the maximum size (in pixels) for this scale.
    */
    maximumValue?: number | string;
    /**
     * Gets or sets whether the scale is logarithmic.
    */
    isLogarithmic?: boolean | string;
    /**
     * Gets or sets the logarithm base for this scale.
    */
    logarithmBase?: number | string;
    /**
     * Event raised when a property (including "effective" and non-dependency property) value changes.
    */
    propertyUpdated?: (s: IgrSizeScale, e: IgrPropertyUpdatedEventArgs) => void;
}
