import { IgPoint } from "igniteui-react-core";
import { IgrSplineSeriesBase, IIgrSplineSeriesBaseProps } from "./igr-spline-series-base";
import { SplineFragmentBase } from "./SplineFragmentBase";
/**
 * Represents one part in a StackedSplineSeries or StackedSplineAreaSeries.
*/
export declare abstract class IgrSplineFragmentBase<P extends IIgrSplineFragmentBaseProps = IIgrSplineFragmentBaseProps> extends IgrSplineSeriesBase<P> {
    /**
                                 * @hidden
                                 */
    readonly i: SplineFragmentBase;
    constructor(props: P);
    /**
     * Gets whether the current series is a stack fragment.
    */
    readonly isFragment: boolean;
    getSeriesValuePosition(world: IgPoint, useInterpolation: boolean, skipUnknowns: boolean): IgPoint;
}
export interface IIgrSplineFragmentBaseProps extends IIgrSplineSeriesBaseProps {
}
